#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define		cvers	%(echo `c++ -dumpversion`)
%define		cmach	%(echo `c++ -dumpmachine`)
%define		_clang	clang
#-----------------------------------------------------------------------------
Name		:	llvm
Version		:	18.1.7
Release		:	17.0.10.rel%{?dist}
Summary		:	%{name} Engine

Group		:	Applications/System

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	LLVM Release License
URL		:	http://llvm.org/
			#https://github.com/llvm/llvm-project/releases/tag

Source0		:	%{name}-%{version}.src.tar.xz
Source1		:	%{name}-cmake-%{version}.src.tar.xz
Source2		:	%{name}-third-party-%{version}.src.tar.xz
Source3		:	clang-%{version}.src.tar.xz

#-----------------------------------------------------------------------------
BuildRequires	:	Babel
BuildRequires	:	gcc-c++
BuildRequires	:	meson
BuildRequires	:	ninja
BuildRequires	:	cmake
BuildRequires	:	python
BuildRequires	:	python3-commonmark
BuildRequires	:	python3-docutils
BuildRequires	:	python3-libstemmer
BuildRequires	:	python3-Pygments
BuildRequires	:	python3-pytz
BuildRequires	:	python3-recommonmark
BuildRequires	:	python3-sphinx
BuildRequires	:	python3-MyST-Parser
BuildRequires	:	python3-pyyaml
BuildRequires	:	python3-markdown-it-py
BuildRequires	:	python3-mdit_py_plugins

Requires	:	%{name}-libs	=  %{version}-%{release}
#-----------------------------------------------------------------------------
%description
The '%{name}' package contains a collection of modular and reusable
compiler and toolchain technologies. The Low Level Virtual Machine
(LLVM) Core libraries provide a modern source and target-independent
optimizer, along with code generation support for many popular CPUs
(as well as some less common ones!). These libraries are built around
a well specified code representation known as the LLVM intermediate
representation ("LLVM IR"). 

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%doc CREDITS.TXT README.txt 
%{_bindir}/%{name}-*
%{_bindir}/bugpoint
%{_bindir}/dsymutil
%{_bindir}/llc
%{_bindir}/lli
%{_bindir}/amdgpu-arch
%{_bindir}/nvptx-arch
%{_bindir}/opt
%{_bindir}/sancov
%{_bindir}/sanstats
%{_bindir}/verify-uselistorder
%{_libdir}/libLLVM*.a
%{_datadir}/opt-viewer/opt*
%{_datadir}/opt-viewer/style.css
%{_mandir}/man1/*.1.gz

#=============================================================================
%package		libs

Summary		:	LLVM shared libraries


#-----------------------------------------------------------------------------
%description 		libs
Shared libraries for the LLVM compiler infrastructure.

#-----------------------------------------------------------------------------
%files 			libs
%defattr(-,root,root,-)
%{_libdir}/LLVMgold.so
%{_libdir}/libLLVM*.so*
%{_libdir}/libLTO*.so*
%{_libdir}/libRemarks.so*

#=============================================================================
%package		doc

Summary		:	Documentation for LLVM

Requires	:	%{name}	=	%{version}-%{release}

BuildArch	:	noarch

#-----------------------------------------------------------------------------
%description		doc
Documentation for the LLVM compiler infrastructure.


#-----------------------------------------------------------------------------
%files			doc
%defattr(-,root,root,-)
%{_defaultdocdir}/%{name}-%{version}/%{name}/

#=============================================================================
%package		devel

Summary		:	Libraries and header files for LLVM

Requires	:	%{name}		=  %{version}-%{release}

#-----------------------------------------------------------------------------
%description		devel
This package contains library and header files needed to develop new
native programs that use the LLVM infrastructure.


#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_bindir}/%{name}-config
%{_includedir}/%{name}/*
%{_includedir}/%{name}-c/*.h
%{_includedir}/%{name}-c/Transforms/*.h
%{_libdir}/cmake/%{name}/*.cmake
%{_libdir}/cmake/%{name}/%{name}-driver-template.cpp.in
%{_libdir}/libLLVM.so

#=============================================================================
%package		clang

Summary		:	A C language family front-end for LLVM

Requires	:	%{name}		=  %{version}-%{release}

#-----------------------------------------------------------------------------
%description 		clang
clang: noun
    1. A loud, resonant, metallic sound.
    2. The strident call of a crane or goose.
    3. C-language family front-end toolkit.

The goal of the Clang project is to create a new C, C++, Objective C
and Objective C++ front-end for the LLVM compiler. Its tools are built
as libraries and designed to be loosely-coupled and extensible.

#-----------------------------------------------------------------------------
%files 			clang
%defattr(-,root,root,-)
%{_bindir}/analyze-build
%{_bindir}/diagtool
%{_bindir}/c-index-test
%{_bindir}/git-clang-format
%{_bindir}/hmaptool
%{_bindir}/intercept-build
%{_bindir}/scan-build
%{_bindir}/scan-build-py
%{_bindir}/scan-view
%{_bindir}/%{_clang}*
%{_libdir}/%{_clang}/*
%{_libdir}/libear/*
%{_libdir}/lib%{_clang}.so.*
%{_libdir}/lib%{_clang}-cpp.so.*
%{_libdir}/lib%{_clang}*.a
%{_libdir}/libscanbuild/*.py
%{_libdir}/libscanbuild/resources/*.js
%{_libdir}/libscanbuild/resources/scanview.css
%{_libexecdir}/c++-analyzer
%{_libexecdir}/ccc-analyzer
%{_libexecdir}/analyze-c++
%{_libexecdir}/analyze-cc
%{_libexecdir}/intercept-c++
%{_libexecdir}/intercept-cc
%{_datadir}/%{_clang}/
%{_datadir}/scan-build/*
%{_datadir}/scan-view/*

#=============================================================================
%package		clang-devel

Summary		:	Header files for clang

#-----------------------------------------------------------------------------
Requires	:	%{name}-clang	=  %{version}-%{release}

#-----------------------------------------------------------------------------
%description 		clang-devel
This package contains header files for the Clang compiler.

#-----------------------------------------------------------------------------
%files 			clang-devel
%defattr(-,root,root,-)
%{_includedir}/%{_clang}-c/*
%{_includedir}/%{_clang}/*
%{_libdir}/lib%{_clang}.so
%{_libdir}/lib%{_clang}-cpp.so
%{_libdir}/cmake/%{_clang}/*.cmake
%{_defaultdocdir}/%{name}-%{version}/clang/

#=============================================================================
%prep
%setup -q	-n %{name}-%{version}.src
tar xf %{SOURCE1} 
tar xf %{SOURCE2} 

sed -i									\
  -e '/LLVM_COMMON_CMAKE_UTILS/s@../cmake@cmake-%{version}.src@'	\
  CMakeLists.txt  

sed -i									\
  -e'/LLVM_THIRD_PARTY_DIR/s@../third-party@third-party-%{version}.src@'\
  cmake/modules/HandleLLVMOptions.cmake

tar xf %{SOURCE3} -C tools
mv tools/clang-%{version}.src tools/clang

#-----------------------------------------------------------------------------
#building application
%build

%define	maxjob %(/usr/bin/getconf _NPROCESSORS_ONLN)
%define _smp_mflags -j%{maxjob}
CC=gcc CXX=g++						\
cmake							\
	-S .						\
	-B _bld						\
	-G Ninja					\
	-D CMAKE_INSTALL_PREFIX=%{_prefix}		\
	-D CMAKE_BUILD_TYPE=Release			\
	-D LLVM_PARALLEL_LINK_JOBS=%{maxjob}		\
	-D LLVM_ENABLE_FFI=ON				\
	-D LLVM_BUILD_LLVM_DYLIB=ON			\
	-D LLVM_LINK_LLVM_DYLIB=ON			\
	-D LLVM_ENABLE_RTTI=ON				\
	-D LLVM_ENABLE_PLUGINS=ON			\
	-D LLVM_TARGETS_TO_BUILD="host;AMDGPU;BPF"	\
	-D LLVM_BUILD_TESTS=ON				\
	-D LLVM_BINUTILS_INCDIR=%{_includedir}		\
	-D LLVM_HOST_TRIPLE=`gcc -dumpmachine`		\
	-D LLVM_DEFAULT_TARGET_TRIPLE=`gcc -dumpmachine`\
	-D LLVM_INCLUDE_BENCHMARKS=OFF			\


#Compiling application
cmake							\
	--build						\
		_bld					\

cmake							\
	-S .						\
	-B _bld						\
	-G Ninja					\
	-D CMAKE_INSTALL_DOCDIR=%{_defaultdocdir}/%{name}-%{version}	\
	-D LLVM_PARALLEL_LINK_JOBS=%{maxjob}		\
	-D LLVM_BUILD_DOCS=ON 				\
	-D LLVM_ENABLE_SPHINX=ON			\
	-D SPHINX_WARNINGS_AS_ERRORS=OFF		\

#Compiling manual
cmake							\
	--build 					\
		_bld					\
	--target					\
		docs-llvm-man				\
		docs-llvm-html				\
		docs-clang-man				\
		docs-clang-html				\


#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}


DESTDIR=%{buildroot}					\
cmake							\
	--install _bld					\

install -d -m755 					\
	%{buildroot}%{_mandir}/man1
install -m644 						\
	_bld/docs/man/*					\
	%{buildroot}%{_mandir}/man1/

install -d -m755 					\
	%{buildroot}%{_defaultdocdir}/%{name}-%{version}

rm							\
	%{buildroot}%{_defaultdocdir}/%{name}-%{version}/*/html/.buildinfo

#-----------------------------------------------------------------------------
%changelog
